/*
 * NewClass.java
 *
 * Created on 24 de Outubro de 2005, 18:57
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package xmlprovider;

import common.ApplicationException;
import importexport.ImportExport;
import importexport.PessoaInfo;
import java.util.List;

// XML support
import java.io.File;
import java.util.ArrayList;
import org.w3c.dom.Document;
import org.w3c.dom.*; 
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;


/**
 *
 * @author Paulo Sousa
 */
public class NewClass implements ImportExport
{
    
    /** Creates a new instance of NewClass */
    public NewClass() {
    }

        // This method writes a DOM document to a file
    private void writeXmlFile(Document doc, String filename) {
        try {
            // Prepare the DOM document for writing
            Source source = new DOMSource(doc);
    
            // Prepare the output file
            File file = new File(filename);
            Result result = new StreamResult(file);
    
            // Write the DOM document to the file
            Transformer xformer = TransformerFactory.newInstance().newTransformer();
            xformer.transform(source, result);
        } catch (TransformerConfigurationException e) {
        } catch (TransformerException e) {
        }
    }

    public void doExport(List<PessoaInfo> data) throws java.io.IOException, ApplicationException
    {
        try
        {
            DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
            DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
            Document doc = docBuilder.newDocument();
            
            Element root = doc.createElement("pessoas");
            doc.appendChild(root);

            for(PessoaInfo pi : data)
            {
                Element newChild = doc.createElement("pessoa");
                newChild.setAttribute("nome", pi.Nome);
                newChild.setAttribute("idade", String.valueOf(pi.Idade));
                        
                root.appendChild(newChild);
            }
            
            writeXmlFile(doc, "c:\\temp\\xml-data.xml");
        }
        catch (javax.xml.parsers.ParserConfigurationException ex)
        {
            throw new ApplicationException("erro parser XML", ex);
        }
    }
    
    public List<PessoaInfo> doImport() throws java.io.IOException, ApplicationException
    {
        List<PessoaInfo> ret = new ArrayList();
        
        try {
        DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
        DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
        Document doc = docBuilder.parse (new File("c:\\temp\\xml-data.xml"));

        // normalize text representation
        doc.getDocumentElement ().normalize ();

        NodeList listOfPersons = doc.getElementsByTagName("pessoa");
        int totalPersons = listOfPersons.getLength();
        for(int s=0; s < listOfPersons.getLength() ; s++)
        {
            Node personNode = listOfPersons.item(s);
            NamedNodeMap attrs = personNode.getAttributes();
            Node nomeNode = attrs.getNamedItem("nome");
            String nome = nomeNode.getNodeValue();
            
            Node idadeNode = attrs.getNamedItem("idade");
            String idade = idadeNode.getNodeValue();
            
            ret.add(new PessoaInfo(nome,  Integer.parseInt(idade)));
        }
        }catch (SAXParseException err) {
            throw new ApplicationException("erro Parser SAX", err);
        }catch (SAXException e) {
            throw new ApplicationException("erro SAX", e);
        }
        catch (javax.xml.parsers.ParserConfigurationException ex)
        {
            throw new ApplicationException("erro parser XML", ex);
        }
    return ret;
    }
}
